.586
.XMM
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include TestStrLen.inc

AxStrLenSSE1 PROTO :DWORD
AxStrLenMMX PROTO :DWORD
lszLenMMX PROTO :DWORD

include \programming\RadASM\masm\inc\debug.inc
includelib \programming\RadASM\masm\lib\debug.lib

DBGWIN_DEBUG_ON = 1 ; include debug info into the program
DBGWIN_EXT_INFO = 1 ; include extra debug info into the program

.data
ALIGN 16
StringToTest	DB	"Hello There",0

.code

start:
	invoke GetModuleHandle,0
	mov hInstance,eax
	ALIGN 16
	invoke lszLenMMX,offset StringToTest
	PrintDec eax
	invoke AxStrLenSSE1,offset StringToTest
	PrintDec eax
	invoke AxStrLenMMX,offset StringToTest
	PrintDec eax
	invoke ExitProcess,0

ALIGN 16
AxStrLenSSE1	proc STDCALL lpszStr:DWORD	; SSE1 safe, ECX safe :), fast with unaligned strings
	;int 3
	mov edx,[esp+4]
	mov eax,[esp+4]
	add esp,-14h
	movups [esp],xmm7
	mov [esp+16],ecx
	and edx,-10h
	mov ecx,0fh
	pxor xmm7,xmm7
	and ecx,eax
	jz @F
	pcmpeqb xmm7,[edx]
	add edx,10h
	pmovmskb eax,xmm7
	shr eax,cl
	bsf eax,eax
	jnz @ret
	@@:
	align 16
	@@:
	pcmpeqb xmm7,[edx]
	add edx,16
	pmovmskb eax,xmm7
	test eax,eax
	jz @B	
	
	bsf eax,eax
	sub edx,[esp+4+16+4]
	lea eax,[eax+edx-10h]
	
	@ret:
	movups xmm7,[esp]
	mov ecx,[esp+16]
	add esp,14h
	ret 4	
	
AxStrLenSSE1	endp

AxStrLenMMX	proc STDCALL lpszStr:DWORD	; SSE safe, because MMX :), ECX safe :), trashed last FPU reg :)
	;int 3
	mov edx,[esp+4]
	@@:
	pxor mm7,mm7		; if carry out this from loop, then loop is slower
	pcmpeqb mm7,[edx]	; if you check this, don't forgot change count of dup to 9 (not 12)
	add edx,8
	pmovmskb eax,mm7
	test eax,eax
	jz @B
	bsf eax,eax
	sub edx,[esp+4]
	lea eax,[eax+edx-8]
	ret 4
AxStrLenMMX	endp

lszLenMMX proc pString:DWORD

	mov eax,[pString]
	nop
	nop ; fill in stack frame+mov to 8 bytes

	pxor mm0,mm0
	nop ; fill pxor to 4 bytes
	pxor mm1,mm1
	nop ; fill pxor to 4 bytes

	@@: ; this is aligned to 16 bytes
	movq mm0,[eax]
	pcmpeqb mm0,mm1
	add eax,8
	pmovmskb ecx,mm0
	or ecx,ecx
	jz @B

	sub eax,[pString]

	bsf ecx,ecx
	sub eax,8
	add eax,ecx

	emms

	
   RET

lszLenMMX ENDP

end start
